//
// https://www.ramecera.it/myscrewdriver.html
// e-mail: screwdriver@ramecera.it
//
/* This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License v1.0 which accompanies this
 * distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html */
package it.ramecera.salad.graphic;

import javax.swing.JLabel;
import javax.swing.JProgressBar;

/**
 * <p>
 * Simple union of a progress bar and 2 labels, one on the left (named
 * head) and one above.
 * </p>
 * <p>
 * Company: Ramecera™<br>
 * Creation date: 2020-06-01<br>
 * Last updated: 2020-06-01
 * </p>
 * <p>
 * Changes:<br>
 * </p>
 * 
 * @author M. Maglioni */
public class Dynamics {

	/** the progress bar */
	public JProgressBar pb;
	/** the label, generally above the progress bar */
	public JLabel left;
	/** the label on the left */
	public JLabel head;
	/** synchrony */
	public ProgressBarAccess access;
	/** visibility */
	public boolean visibile = false;

	/** @param pb progress bar object
	 * @param left label above the progress bar
	 * @param head label to the left of the progress bar */
	public Dynamics(JProgressBar pb, JLabel left, JLabel head) {
		super();
		this.pb = pb;
		this.left = left;
		this.head = head;
		access = new ProgressBarAccess(pb.getBounds(), left.getBounds(),
				head.getBounds());
	}
}
